from subprocess import check_output
import random
import os

def set_properties ():
    properties = open('init.aesp', 'r', encoding='utf-8')
    d_settings = ['', '', '', [randomStr(), randomStr(), randomStr()], [5, 5, 5], 'e']
    d_debug = ['true', 'true', 'true', 5, 1]
    h_debug = ['false', 'false', 'false', 101, 0]
    d_p_input = ['all', 'all', 'true', 'true', 'true']
    d_p_output = ['true', 'true', 'true', 'true', 'true']
    d_adv = ['.aes', '.aes.dec', '.aes.chk']

    settings = ['', '', '', [], [], 'e']
    debug = ['', '', '', 0, 0]
    p_input = ['', '', '', '', '']
    p_output = ['', '', '', '', '']
    adv = ['', '', '']

    mode = 0
    for command in properties:
        command = command.strip()
        if command == '[Settings]':
            mode = 1
        elif command == '[Debug]':
            mode = 2
        elif command == '[P_Input]':
            mode = 3
        elif command == '[P_Output]':
            mode = 4
        elif command == '[Adv]':
            mode = 5
        elif len(command) > 0 and command[0] == "[" and command[len(command)-1] == "]":
            mode = 0
        else:
            if mode == 1:
                if command[:6] == 'input=':
                    settings[0] = command[6:]
                elif command[:7] == 'output=':
                    settings[1] = command[7:]
                elif command[:11] == 'chk_output=':
                    settings[2] = command[11:]
                elif command[:5] == 'keys=':
                    if len(command[5:]) > 0:
                        settings[3] = string2List(command[5:], 'not_i')
                    else:
                        settings[3] = d_settings[3]
                elif command[:8] == 'numKeys=':
                    if len(command[8:]) > 0:
                        settings[4] = string2List(command[8:], 'i')
                    else:
                        settings[4] = d_settings[4]
                elif command[:9] == 'sequence=':
                    settings[5] = command[9:]
            elif mode == 2:
                if command[:11] == 'printInput=':
                    debug[0] = command[11:]
                elif command[:12] == 'printOutput=':
                    debug[1] = command[12:]
                elif command[:10] == 'printProg=':
                    debug[2] = command[10:]
                elif command[:8] == 'progInt=':
                    debug[3] = command[8:]
                elif command[:8] == 'progRnd=':
                    debug[4] = command[8:]
                elif command[:6] == 'debug=':
                    if command[6:] == 'default':
                        debug = d_debug
                    elif command[6:] == 'hidden':
                        debug = h_debug
            elif mode == 3:
                if command[:10] == 'printKeys=':
                    if (command[10] == '[') and (command[len(command)-1] == ']'):
                        p_input[0] = string2List(command[10:], 'i')
                    else:
                        p_input[0] = command[10:]
                elif command[:13] == 'printNumKeys=':
                    if (command[13] == '[') and (command[len(command)-1] == ']'):
                        p_input[1] = string2List(command[13:], 'i')
                    else:
                        p_input[1] = command[13:]
                elif command[:15] == 'printInputFrom=':
                    p_input[2] = command[15:]
                elif command[:14] == 'printOutputTo=':
                    p_input[3] = command[14:]
                elif command[:17] == 'printChkOutputTo=':
                    p_input[4] = command[17:]
            elif mode == 4:
                if command[:16] == 'printOutputedTo=':
                    p_output[0] = command[16:]
                elif command[:19] == 'printChkOutputedTo=':
                    p_output[1] = command[19:]
                elif command[:14] == 'printInitSize=':
                    p_output[2] = command[14:]
                elif command[:15] == 'printFinalSize=':
                    p_output[3] = command[15:]
                elif command[:15] == 'printCompRatio=':
                    p_output[4] = command[15:]
            elif mode == 5:
                if command[:8] == 'encLtrs=':
                    adv[0] = command[8:]
                elif command[:8] == 'decLtrs=':
                    adv[1] = command[8:]
                elif command[:8] == 'chkLtrs=':
                    adv[2] = command[8:]
    
    settingsCounter = 0
    while settingsCounter != len(settings):
        if len(settings[settingsCounter]) == 0:
            settings[settingsCounter] == d_settings[settingsCounter]
        settingsCounter += 1
    
    debugCounter = 0
    while debugCounter != len(debug):
        if typeStr(debug[debugCounter]) != "<class 'int'>":
            if len(debug[debugCounter]) == 0:
                debug[debugCounter] == d_debug[debugCounter]
        debugCounter += 1
    
    p_inputCounter = 0
    while p_inputCounter != len(p_input):
        if len(p_input[p_inputCounter]) == 0:
            p_input[p_inputCounter] == d_p_input[p_inputCounter]
        p_inputCounter += 1
    
    p_outputCounter = 0
    while p_outputCounter != len(p_output):
        if len(p_output[p_outputCounter]) == 0:
            p_output[p_outputCounter] == d_p_output[p_outputCounter]
        p_outputCounter += 1
    
    advCounter = 0
    while advCounter != len(adv):
        if len(adv[advCounter]) == 0:
            adv[advCounter] == d_adv[advCounter]
        advCounter += 1
    
    return settings, debug, p_input, p_output, adv

def randomStr():
    length = random.randint(1, 15)
    counter = 0
    fStr = ''
    while counter <= length:
        fStr += chr(random.randint(48, 126))
        counter += 1
    return fStr

def typeStr (object):
    answer = str(type(object))
    return answer

def string2List (string, flag):
    theList = []
    string = string[1:len(string)-1]
    fStr = ''
    for chtr in string:
        if chtr == ',':
            if flag == 'i':
                theList.append(int(fStr))
            else:
                theList.append(fStr)
            fStr = ''
        else:
            fStr += chtr
    if flag == 'i':
        theList.append(int(fStr))
    else:
        theList.append(fStr)
    return theList

def string2ListByChtr (string, chtrFlag):
    theList = []
    fStr = ''
    for chtr in string:
        if chtr == chtrFlag:
            theList.append(chtr)
            fStr = ''
        else:
            fStr += chtr
    theList.append(chtr)
    return theList

def list2Str (theList):
    fStr = ''
    for theEntry in theList:
        fStr += str(theEntry) + ', '
    fStr = fStr[:len(fStr)-2]
    return fStr

def list2initStr (theList):
    fStr = '['
    for theEntry in theList:
        fStr += str(theEntry) + ','
    fStr = fStr[:len(fStr)-1]
    fStr += ']'
    return fStr

def getSizeStr (location):
    intStr = getSize(location)
    letter = ""
    if intStr < 1000:
        letter = "B"
        fStr = str(intStr) + letter
    if intStr >= 1000 and intStr < 1000000:
        letter = "kB"
        fStr = str(intStr/1000) + letter
    if intStr >= 1000000 and intStr < 1000000000:
        letter = "MB"
        fStr = str(intStr/1000000) + letter
    if intStr >= 1000000000:
        letter = "GB"
        fStr = str(intStr/1000000000) + letter
    return fStr

def getSize (location):
    fileList = ((str(check_output("dir " + location + " /a:-d", shell=True).decode())).split())
    flag = False
    for fileStr in fileList:
        if flag:
            theStr = fileStr
            break
        else:
            if fileStr == 'File(s)':
                flag = True
    f_fileStr = ''
    for digit in theStr:
        if digit != ",":
            f_fileStr += digit
    return int(f_fileStr)

os.system('cls')

propertiesList = set_properties()
settings = propertiesList[0]
debug = propertiesList[1]
p_input = propertiesList[2]
p_output = propertiesList[3]
adv = propertiesList[4]

input_file_path = settings[0]
output_file_path = settings[1]
if (settings[2] == 'false') or (settings[2] == ''):
    bool_chk_output = False
    chk_output_file_path = ''
else:
    bool_chk_output = True
    chk_output_file_path = settings[2]
iterations = len(settings[3])
passwords = settings[3]
num_passwords = settings[4]
flag = settings[5]

if debug[0].capitalize() == 'True':
    printInput = True
else:
    printInput = False
if debug[1].capitalize() == 'True':
    printOutput = True
else:
    printOutput = False
if debug[2].capitalize() == 'True':
    printProg = True
else:
    printProg = False
progInt = debug[3]
progRnd = debug[4]

if p_input[0] == 'all':
    printKeys = list2Str(passwords)
else:
    printKeys = ''
    for printKeyEntry in p_input[0]:
        printKeys += passwords[printKeyEntry-1] + ', '
    printKeys = printKeys[:len(printKeys)-2]
bPrintKeys = True
if len(p_input[0]) == 0:
    bPrintKeys = False
if p_input[1] == 'all':
    printNumKeys = list2Str(num_passwords)
else:
    printNumKeys = ''
    for printNumKeyEntry in p_input[1]:
        printNumKeys += str(num_passwords[printNumKeyEntry-1]) + ', '
    printNumKeys = printNumKeys[:len(printNumKeys)-2]
bPrintNumKeys = True
if len(p_input[1]) == 0:
    bPrintNumKeys = False
if p_input[2].capitalize() == 'True':
    printInputFrom = True
else:
    printInputFrom = False
if p_input[3].capitalize() == 'True':
    printOutputTo = True
else:
    printOutputTo = False
if p_input[4].capitalize() == 'True':
    printChkOutputTo = True
else:
    printChkOutputTo = False

if p_output[0].capitalize() == 'True':
    printOutputedTo = True
else:
    printOutputedTo = False
if p_output[1].capitalize() == 'True':
    printChkOutputedTo = True
else:
    printChkOutputedTo = False
if p_output[2].capitalize() == 'True':
    printInitSize = True
else:
    printInitSize = False
if p_output[3].capitalize() == 'True':
    printFinalSize = True
else:
    printFinalSize = False
if p_output[4].capitalize() == 'True':
    printCompRatio = True
else:
    printCompRatio = False

encLtrs = adv[0]
decLtrs = adv[1]
chkLtrs = adv[2]

textFileName = input_file_path
ciphertextFileName = output_file_path + '.' + encLtrs
plaintextFileName = chk_output_file_path + chkLtrs
dectextFileName = output_file_path + decLtrs

versions = open('versions.txt', 'r')
versions_list = []
for versions_str in versions:
    versions_list.append(versions_str)

printVersions = 'Using AES version ' + versions_list[0] + 'Using HSED version ' + versions_list[1] + '\n'

print(printVersions)
if flag == 'e':
    randomPasswords = [randomStr(), randomStr(), randomStr()]
    randomNumPasswords = [random.randint(5, 10), random.randint(5, 10), random.randint(5, 10)]
    printInputStr = ''
    if printInput:
        if printInputFrom:
            printInputStr += 'Inputing from: ' + textFileName
        if printInputFrom and bPrintKeys:
            printInputStr += '\n'
        if bPrintKeys:
            printInputStr += 'Encoding using key(s): ' + printKeys + '\n'
            printInputStr += 'Encoding using HS key(s): ' + list2Str(randomPasswords)
        if bPrintKeys and bPrintNumKeys:
            printInputStr += '\n'
        if bPrintNumKeys:
            printInputStr += 'Encoding using combination(s): ' + printNumKeys + '\n'
            printInputStr += 'Encoding using HS combination(s): ' + list2Str(randomNumPasswords)
        if bPrintNumKeys and printOutputTo:
            printInputStr += '\n'
        if printOutputTo:
            printInputStr += 'Outputing to: ' + ciphertextFileName
        if printOutputTo and printChkOutputTo and bool_chk_output:
            printInputStr += '\n'
        if printChkOutputTo and bool_chk_output:
            printInputStr += 'Check outputing to: ' + plaintextFileName
    print(printInputStr)
    print('Reading file...')
    hs_init = open('hs_init.aesp', 'w', encoding='utf-8')
    hs_init.write('[Settings]\ninput='+textFileName+'\noutput='+ciphertextFileName+'.tmp\nkeys='+list2initStr(randomPasswords)+'\nnumKeys='+list2initStr(randomNumPasswords)+'\nsequence=e\n[Adv]\nencLtrs='+adv[0]+'\ndecLtrs='+adv[1]+'\nchkLtrs='+adv[2])
    hs_init.close()
    print('Encrypting file...')
    os.system('HSED.exe')
    print(printVersions)
    print(printInputStr+'\nReading file...\nEncrypting file...')
    state = open('state.txt', 'r', encoding='utf-8')
    while True:
        if state.read() == 'done':
            break
    state.close()
    state_w = open('state.txt', 'w', encoding='utf-8')
    state_w.write('')
    state_w.close()
    ciphertextFile = open(ciphertextFileName+'.tmp.'+adv[0], 'a', encoding='utf-8')
    ciphertextFile.write('\n'+randomPasswords[0]+'\n'+randomPasswords[1]+'\n'+randomPasswords[2]+'\n'+str(randomNumPasswords[0])+'\n'+str(randomNumPasswords[1])+'\n'+str(randomNumPasswords[2]))
    ciphertextFile.close()
    hs_init = open('hs_init.aesp', 'w', encoding='utf-8')
    hs_init.write('[Settings]\ninput='+ciphertextFileName+'.tmp.'+adv[0]+'\noutput='+output_file_path+'\nkeys='+list2initStr(passwords)+'\nnumKeys='+list2initStr(num_passwords)+'\nsequence=e\n[Adv]\nencLtrs='+adv[0]+'\ndecLtrs='+adv[1]+'\nchkLtrs='+adv[2])
    hs_init.close()
    print('Wrinting file...')
    os.system('HSED.exe')
    print(printVersions)
    print(printInputStr+'\nReading file...\nEncrypting file...\nWrinting file...')
    state = open('state.txt', 'r', encoding='utf-8')
    while True:
        if state.read() == 'done':
            break
    state.close()
    state_w = open('state.txt', 'w', encoding='utf-8')
    state_w.write('')
    state_w.close()
    os.system('del ' + ciphertextFileName + '.tmp.' + adv[0])
    if printOutput:
        if printOutputedTo:
            print('Outputed to: ' + ciphertextFileName)
        if printChkOutputedTo and bool_chk_output:
            print('Check outputed to: ' + plaintextFileName)
        if printInitSize:
            print('Initial file size: ' + getSizeStr(textFileName))
        if printFinalSize:
            print('Final file size: ' + getSizeStr(ciphertextFileName))
        if printCompRatio:
            print('Compression ratio: ' + str(round((getSize(ciphertextFileName)*100/getSize(textFileName)), 1)) + '%')
elif flag == 'd':
    printInputStr = ''
    if printInput:
        if printInputFrom:
            printInputStr += 'Inputing from: ' + textFileName
        if printInputFrom and bPrintKeys:
            printInputStr += '\n'
        if bPrintKeys:
            printInputStr += 'Decoding using key(s): ' + printKeys
        if bPrintKeys and bPrintNumKeys:
            printInputStr += '\n'
        if bPrintNumKeys:
            printInputStr += 'Decoding using combination(s): ' + printNumKeys
        if bPrintNumKeys and printOutputTo:
            printInputStr += '\n'
        if printOutputTo:
            printInputStr += 'Outputing to: ' + ciphertextFileName + '.' + adv[1]
    print('Reading file...')
    hs_init = open('hs_init.aesp', 'w', encoding='utf-8')
    hs_init.write('[Settings]\ninput='+textFileName+'\noutput='+ciphertextFileName+'.tmp\nkeys='+list2initStr(passwords)+'\nnumKeys='+list2initStr(num_passwords)+'\nsequence=d\n[Adv]\nencLtrs='+adv[0]+'\ndecLtrs='+adv[1]+'\nchkLtrs='+adv[2])
    hs_init.close()
    print('Decrypting file...')
    os.system('HSED.exe')
    print(printVersions)
    print(printInputStr+'\nReading file...\nDecrypting file...')
    state = open('state.txt', 'r', encoding='utf-8')
    while True:
        if state.read() == 'done':
            break
    state.close()
    state_w = open('state.txt', 'w', encoding='utf-8')
    state_w.write('')
    state_w.close()
    ciphertextFile_r = open(ciphertextFileName+'.tmp.'+adv[1], 'r', encoding='utf-8')
    line_list = []
    for ciphertextFile_r_line in ciphertextFile_r:
        line_list.append(ciphertextFile_r_line)
    ciphertextFile_r.close()
    ciphertextList = line_list[:len(line_list)-6]
    ciphertext = ''
    for ciphertextLine in ciphertextList:
        ciphertext += ciphertextLine
    ciphertext = ciphertext[:len(ciphertext)-1]
    fPasswords = []
    for password_line in line_list[len(line_list)-6:len(line_list)-3]:
        fPasswords.append(password_line[:len(password_line)-1])
    fNumPasswords = []
    numPassCounter = 1
    for num_password_line in line_list[len(line_list)-3:]:
        if numPassCounter != len(line_list[len(line_list)-3:]):
            fNumPasswords.append(num_password_line[:len(num_password_line)-1])
        else:
            fNumPasswords.append(num_password_line)
        numPassCounter += 1
    ciphertextFile_w = open(ciphertextFileName+'.tmp.'+adv[0], 'w', encoding='utf-8')
    ciphertextFile_w.write(ciphertext)
    ciphertextFile_w.close()
    hs_init = open('hs_init.aesp', 'w', encoding='utf-8')
    hs_init.write('[Settings]\ninput='+ciphertextFileName+'.tmp.'+adv[0]+'\noutput='+input_file_path+'\nkeys='+list2initStr(fPasswords)+'\nnumKeys='+list2initStr(fNumPasswords)+'\nsequence=d\n[Adv]\nencLtrs='+adv[0]+'\ndecLtrs='+adv[1]+'\nchkLtrs='+adv[2])
    hs_init.close()
    print('Wrinting file...')
    os.system('HSED.exe')
    print(printVersions)
    print(printInputStr+'\nReading file...\nDecrypting file...\nWrinting file...')
    state = open('state.txt', 'r', encoding='utf-8')
    while True:
        if state.read() == 'done':
            break
    state.close()
    state_w = open('state.txt', 'w', encoding='utf-8')
    state_w.write('')
    state_w.close()
    os.system('del ' + input_file_path + '.tmp.' + adv[1])
    os.system('del ' + input_file_path + '.tmp.' + adv[0])
    print('HS keys used: ' + list2Str(fPasswords))
    print('HS combinations used: ' + list2Str(fNumPasswords))
    if printOutput:
        if printOutputedTo:
            print('Outputed to: ' + textFileName + '.' + adv[1])
        if printInitSize:
            print('Initial file size: ' + getSizeStr(textFileName))
        if printFinalSize:
            print('Final file size: ' + getSizeStr(textFileName+'.'+adv[1]))
        if printCompRatio:
            print('Compression ratio: ' + str(round((getSize(textFileName+'.'+adv[1])*100/getSize(textFileName)), 1)) + '%')
exitCode = input('Press ENTER/RETURN to exit...')